using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Grouping;

namespace GGC_FilterBar_Dlg
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		private System.Windows.Forms.CheckBox checkBox1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.checkBox1 = new System.Windows.Forms.CheckBox();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridGroupingControl1
			// 
			this.gridGroupingControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl1.Location = new System.Drawing.Point(24, 56);
			this.gridGroupingControl1.Name = "gridGroupingControl1";
			this.gridGroupingControl1.Size = new System.Drawing.Size(424, 272);
			this.gridGroupingControl1.TabIndex = 0;
			this.gridGroupingControl1.Text = "gridGroupingControl1";
			this.gridGroupingControl1.VersionInfo = "3.0.1.0";
			// 
			// checkBox1
			// 
			this.checkBox1.Location = new System.Drawing.Point(136, 16);
			this.checkBox1.Name = "checkBox1";
			this.checkBox1.TabIndex = 1;
			this.checkBox1.Text = "German";
			this.checkBox1.CheckedChanged += new System.EventHandler(this.checkBox1_CheckedChanged);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(472, 358);
			this.Controls.Add(this.checkBox1);
			this.Controls.Add(this.gridGroupingControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			DataTable dt = new DataTable("MyTable");

			 
			int nRows = 10;
			Random r = new Random(123345345);

			
			dt.Columns.Add(new DataColumn(string.Format("Col{0}", 1), typeof(int)));
			dt.Columns.Add(new DataColumn(string.Format("Col{0}", 2)));
			dt.Columns.Add(new DataColumn(string.Format("Col{0}", 3), typeof(DateTime)));

			for(int i = 0; i < nRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = r.Next(100);
				dr[1] = "a" + r.Next(100).ToString();
				if(i % 4 != 0)
					dr[2] = DateTime.Now.AddDays( r.Next(10)).Date;
				//else leave it null
				else
					dr[2] = System.DBNull.Value;

				dt.Rows.Add(dr);
			}

			dt.Rows[2]["Col1"] = DBNull.Value;
			dt.Rows[4]["Col2"] = "";


			this.gridGroupingControl1.DataSource = dt;

			this.gridGroupingControl1.TableDescriptor.AllowNew = false;
			
			//allow 2 filterbar entries
			this.gridGroupingControl1.TopLevelGroupOptions.ShowFilterBar = true;
			this.gridGroupingControl1.TableDescriptor.Columns["Col1"].AllowFilter = true;
			this.gridGroupingControl1.TableDescriptor.Columns["Col2"].AllowFilter = true;
			this.gridGroupingControl1.TableDescriptor.Columns["Col3"].AllowFilter = true;
			this.gridGroupingControl1.TableDescriptor.Columns["Col3"].Appearance.AnyRecordFieldCell.CellType = GridCellTypeName.MonthCalendar; 

			//add a custom cell type
			CustomFilterBarCellModel model = new CustomFilterBarCellModel(this.gridGroupingControl1.TableModel);
			this.gridGroupingControl1.TableModel.CellModels.Add("CustFilterBarCell", model);

			//make filter bar cells use our custom cell type
			this.gridGroupingControl1.TableDescriptor.Appearance.FilterBarCell.CellType = "CustFilterBarCell";
		}

		
		private void checkBox1_CheckedChanged(object sender, System.EventArgs e)
		{
			//make no current cell so the currentcell will be reset when the grid becomes active again.
			this.gridGroupingControl1.TableControl.CurrentCell.ResetCurrentCellWithoutDeactivate();
			CustomFilterBarCellModel model =  this.gridGroupingControl1.TableModel.CellModels["CustFilterBarCell"]
				as CustomFilterBarCellModel;

			if(this.checkBox1.Checked)
			{
				model.FilterBarStrings[0] = "(Keine Auswahl)";
				model.FilterBarStrings[1] = "(Dialogauswahl)";
				model.FilterBarStrings[2] = "gleich";
				model.FilterBarStrings[3] = "nicht gleich";
				model.FilterBarStrings[4] = "groesser";
				model.FilterBarStrings[5] = "groesser oder gleich";
				model.FilterBarStrings[6] = "kleiner";
				model.FilterBarStrings[7] = "kleiner oder gleich";
				model.FilterBarStrings[8] = "Textanfang gleich";
				model.FilterBarStrings[9] = "Textanfang nicht gleich";
				model.FilterBarStrings[10] = "Textende gleich";
				model.FilterBarStrings[11] = "Textende nicht gleich";
				model.FilterBarStrings[12] = "Enthaelt";
				model.FilterBarStrings[13] = "Enthaelt nicht";
				model.FilterBarStrings[14] = "Verwende * fuer beliebige Zeichenfolge";
				model.FilterBarStrings[15] = "Zeige Reihen mit:";
				
			}
			else 
			{
				model.FilterBarStrings[0] = "(all)";
				model.FilterBarStrings[1] = "(custom)";
				model.FilterBarStrings[2] = "equal";
				model.FilterBarStrings[3] = "not equal";
				model.FilterBarStrings[4] = "greater than";
				model.FilterBarStrings[5] = "greater than or equal";
				model.FilterBarStrings[6] = "less than";
				model.FilterBarStrings[7] = "less than or equal";
				model.FilterBarStrings[8] = "begins with";
				model.FilterBarStrings[9] = "does not begin with";
				model.FilterBarStrings[10] = "ends with";
				model.FilterBarStrings[11] = "does not end with";
				model.FilterBarStrings[12] = "contains";
				model.FilterBarStrings[13] = "does not contain";
				model.FilterBarStrings[14] = "Use * to represent any series of characters";
				model.FilterBarStrings[15] = "Show rows where:";
			}
			model.SelectAllText = model.FilterBarStrings[0];
			model.SelectCustomText = model.FilterBarStrings[1];

			
		}

		
		 
	}
}
